library app_info;

import 'dart:convert';

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_core/serializers.dart';

part 'appInfo.g.dart';

abstract class AppInfo implements Built<AppInfo, AppInfoBuilder> {
  AppInfo._();

  factory AppInfo([updates(AppInfoBuilder b)]) = _$AppInfo;

  @BuiltValueField(wireName: 'deviceName')
  String? get deviceName;

  @BuiltValueField(wireName: 'deviceVersion')
  String? get deviceVersion;

  @BuiltValueField(wireName: 'deviceIdentifier')
  String? get deviceIdentifier;

  @BuiltValueField(wireName: 'appVersion')
  String? get appVersion;

  @BuiltValueField(wireName: 'appBuildNumber')
  String? get appBuildNumber;

  String toJson() {
    return json.encode(serializers.serializeWith(AppInfo.serializer, this));
  }

  static AppInfo? fromJson(String jsonString) {
    return serializers.deserializeWith(
        AppInfo.serializer, json.decode(jsonString));
  }

  static Serializer<AppInfo> get serializer => _$appInfoSerializer;
}
