import 'package:flutter/material.dart';
import 'package:puma_core/entities/environment/environment.dart';
import 'package:puma_core/helpers/colorsHelper.dart';

extension ExtEnvironment on Environment {
  static Environment? _instance;

  /// The instance of the [Environment] to use.
  static Environment get instance => _getOrCreateInstance();

  static set instance(Environment env) {
    _instance = env;
  }

  static Environment _getOrCreateInstance() {
    if (_instance != null) {
      return _instance!;
    }

    _instance = Environment();
    return _instance!;
  }

  MaterialColor primarySwatchColor() {
    return getColorFromString(this.themePrimarySwatch);
  }
}
