import 'package:puma_core/constants.dart';
import 'package:puma_core/entities/appInfo/appInfo.dart';

/// The most atomic action.
///
/// All actions related to PUMA will herit of this class.
/// {@category Redux}
abstract class CoreAction {
  /// Time where the action is dispatched.
  int get timestamp;

  /// Identifies the origin of the action (example: "account_kit").
  String get dispatcherKey;
}

class SetAppInfoAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  final AppInfo appInfo;

  SetAppInfoAction(this.appInfo)
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}
