import 'dart:convert';

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_core/entities/appInfo/appInfo.dart';

import '../../serializers.dart';

part 'coreState.g.dart';

abstract class VirtualCoreState {
  // ErrorState get errorState;
  CoreState get coreState;
}

abstract class CoreState implements Built<CoreState, CoreStateBuilder> {
  CoreState._();
  factory CoreState([updates(CoreStateBuilder b)]) = _$CoreState;

  static CoreState initial() {
    return new CoreState((b) => b);
  }

  AppInfo? get appInfo;

  String toJson() {
    return json.encode(serializers.serializeWith(CoreState.serializer, this));
  }

  static CoreState? fromJson(jsonString) {
    return serializers.deserializeWith(
        CoreState.serializer, json.decode(jsonString));
  }

  static Serializer<CoreState> get serializer => _$coreStateSerializer;
}
