library serializers;

import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:puma_core/entities/appInfo/appInfo.dart';
import 'package:puma_core/entities/environment/environment.dart';
import 'package:puma_core/redux/core/coreState.dart';

// import 'error/commonError.dart';
// import 'error/errorState.dart';

part 'serializers.g.dart';

/// Example of how to use built_value serialization.
///
/// Declare a top level [Serializers] field called serializers. Annotate it
/// with [SerializersFor] and provide a `const` `List` of types you want to
/// be serializable.
///
/// The built_value code generator will provide the implementation. It will
/// contain serializers for all the types asked for explicitly plus all the
/// types needed transitively via fields.
///
/// You usually only need to do this once per project.
@SerializersFor([
  // ErrorState,
  CoreState,
  Environment,
  AppInfo,
])
final Serializers serializers =
    (_$serializers.toBuilder()..addPlugin(new StandardJsonPlugin())).build();
final Serializers rawSerializer = _$serializers;
